# Schemas ## List all uploaded schemas `client.SchemaValidation.Schemas.List(ctx, params) (*V4PagePaginationArray[PublicSchema], error)` **get** `/zones/{zone_id}/schema_validation/schemas` Lists all OpenAPI schemas uploaded to API Shield with pagination support. ### Parameters - `params SchemaListParams` - `ZoneID param.Field[string]` Path param: Identifier. - `OmitSource param.Field[bool]` Query param: Omit the source-files of schemas and only retrieve their meta-data. - `Page param.Field[int64]` Query param: Page number of paginated results. - `PerPage param.Field[int64]` Query param: Maximum number of results per page. - `ValidationEnabled param.Field[bool]` Query param: Filter for enabled schemas ### Returns - `type PublicSchema struct{…}` A schema used in schema validation - `CreatedAt Time` - `Kind PublicSchemaKind` The kind of the schema - `const PublicSchemaKindOpenAPIV3 PublicSchemaKind = "openapi_v3"` - `Name string` A human-readable name for the schema - `SchemaID string` A unique identifier of this schema - `Source string` The raw schema, e.g., the OpenAPI schema, either as JSON or YAML - `ValidationEnabled bool` An indicator if this schema is enabled ### Example ```go package main import ( "context" "fmt" "github.com/cloudflare/cloudflare-go" "github.com/cloudflare/cloudflare-go/option" "github.com/cloudflare/cloudflare-go/schema_validation" ) func main() { client := cloudflare.NewClient( option.WithAPIToken("Sn3lZJTBX6kkg7OdcBUAxOO963GEIyGQqnFTOFYY"), ) page, err := client.SchemaValidation.Schemas.List(context.TODO(), schema_validation.SchemaListParams{ ZoneID: cloudflare.F("023e105f4ecef8ad9ca31a8372d0c353"), }) if err != nil { panic(err.Error()) } fmt.Printf("%+v\n", page) } ``` #### Response ```json { "errors": [ { "code": 1000, "message": "message", "documentation_url": "documentation_url", "source": { "pointer": "pointer" } } ], "messages": [ { "code": 1000, "message": "message", "documentation_url": "documentation_url", "source": { "pointer": "pointer" } } ], "result": [ { "created_at": "2014-01-01T05:20:00.12345Z", "kind": "openapi_v3", "name": "petstore schema", "schema_id": "f174e90a-fafe-4643-bbbc-4a0ed4fc8415", "source": "", "validation_enabled": true } ], "success": true, "result_info": { "count": 1, "page": 1, "per_page": 20, "total_count": 2000, "total_pages": 100 } } ``` ## Get details of a schema `client.SchemaValidation.Schemas.Get(ctx, schemaID, params) (*PublicSchema, error)` **get** `/zones/{zone_id}/schema_validation/schemas/{schema_id}` Gets the contents and metadata of a specific OpenAPI schema uploaded to API Shield. ### Parameters - `schemaID string` UUID. - `params SchemaGetParams` - `ZoneID param.Field[string]` Path param: Identifier. - `OmitSource param.Field[bool]` Query param: Omit the source-files of schemas and only retrieve their meta-data. ### Returns - `type PublicSchema struct{…}` A schema used in schema validation - `CreatedAt Time` - `Kind PublicSchemaKind` The kind of the schema - `const PublicSchemaKindOpenAPIV3 PublicSchemaKind = "openapi_v3"` - `Name string` A human-readable name for the schema - `SchemaID string` A unique identifier of this schema - `Source string` The raw schema, e.g., the OpenAPI schema, either as JSON or YAML - `ValidationEnabled bool` An indicator if this schema is enabled ### Example ```go package main import ( "context" "fmt" "github.com/cloudflare/cloudflare-go" "github.com/cloudflare/cloudflare-go/option" "github.com/cloudflare/cloudflare-go/schema_validation" ) func main() { client := cloudflare.NewClient( option.WithAPIToken("Sn3lZJTBX6kkg7OdcBUAxOO963GEIyGQqnFTOFYY"), ) publicSchema, err := client.SchemaValidation.Schemas.Get( context.TODO(), "f174e90a-fafe-4643-bbbc-4a0ed4fc8415", schema_validation.SchemaGetParams{ ZoneID: cloudflare.F("023e105f4ecef8ad9ca31a8372d0c353"), }, ) if err != nil { panic(err.Error()) } fmt.Printf("%+v\n", publicSchema.SchemaID) } ``` #### Response ```json { "errors": [ { "code": 1000, "message": "message", "documentation_url": "documentation_url", "source": { "pointer": "pointer" } } ], "messages": [ { "code": 1000, "message": "message", "documentation_url": "documentation_url", "source": { "pointer": "pointer" } } ], "result": { "created_at": "2014-01-01T05:20:00.12345Z", "kind": "openapi_v3", "name": "petstore schema", "schema_id": "f174e90a-fafe-4643-bbbc-4a0ed4fc8415", "source": "", "validation_enabled": true }, "success": true } ``` ## Upload a schema `client.SchemaValidation.Schemas.New(ctx, params) (*PublicSchema, error)` **post** `/zones/{zone_id}/schema_validation/schemas` Uploads a new OpenAPI schema for API Shield schema validation. The schema defines expected request/response formats for API endpoints. ### Parameters - `params SchemaNewParams` - `ZoneID param.Field[string]` Path param: Identifier. - `Kind param.Field[SchemaNewParamsKind]` Body param: The kind of the schema - `const SchemaNewParamsKindOpenAPIV3 SchemaNewParamsKind = "openapi_v3"` - `Name param.Field[string]` Body param: A human-readable name for the schema - `Source param.Field[string]` Body param: The raw schema, e.g., the OpenAPI schema, either as JSON or YAML - `ValidationEnabled param.Field[bool]` Body param: An indicator if this schema is enabled ### Returns - `type PublicSchema struct{…}` A schema used in schema validation - `CreatedAt Time` - `Kind PublicSchemaKind` The kind of the schema - `const PublicSchemaKindOpenAPIV3 PublicSchemaKind = "openapi_v3"` - `Name string` A human-readable name for the schema - `SchemaID string` A unique identifier of this schema - `Source string` The raw schema, e.g., the OpenAPI schema, either as JSON or YAML - `ValidationEnabled bool` An indicator if this schema is enabled ### Example ```go package main import ( "context" "fmt" "github.com/cloudflare/cloudflare-go" "github.com/cloudflare/cloudflare-go/option" "github.com/cloudflare/cloudflare-go/schema_validation" ) func main() { client := cloudflare.NewClient( option.WithAPIToken("Sn3lZJTBX6kkg7OdcBUAxOO963GEIyGQqnFTOFYY"), ) publicSchema, err := client.SchemaValidation.Schemas.New(context.TODO(), schema_validation.SchemaNewParams{ ZoneID: cloudflare.F("023e105f4ecef8ad9ca31a8372d0c353"), Kind: cloudflare.F(schema_validation.SchemaNewParamsKindOpenAPIV3), Name: cloudflare.F("petstore schema"), Source: cloudflare.F(""), ValidationEnabled: cloudflare.F(true), }) if err != nil { panic(err.Error()) } fmt.Printf("%+v\n", publicSchema.SchemaID) } ``` #### Response ```json { "errors": [ { "code": 1000, "message": "message", "documentation_url": "documentation_url", "source": { "locations": [ ".paths[\"/user/{username}\"].put" ], "pointer": "pointer" } } ], "messages": [ { "code": 1000, "message": "message", "documentation_url": "documentation_url", "source": { "locations": [ ".paths[\"/user/{username}\"].put" ], "pointer": "pointer" } } ], "result": { "created_at": "2014-01-01T05:20:00.12345Z", "kind": "openapi_v3", "name": "petstore schema", "schema_id": "f174e90a-fafe-4643-bbbc-4a0ed4fc8415", "source": "", "validation_enabled": true }, "success": true } ``` ## Edit details of a schema to enable validation `client.SchemaValidation.Schemas.Edit(ctx, schemaID, params) (*PublicSchema, error)` **patch** `/zones/{zone_id}/schema_validation/schemas/{schema_id}` Modifies an existing OpenAPI schema in API Shield, updating the validation rules for associated API operations. ### Parameters - `schemaID string` UUID. - `params SchemaEditParams` - `ZoneID param.Field[string]` Path param: Identifier. - `ValidationEnabled param.Field[bool]` Body param: Flag whether schema is enabled for validation. ### Returns - `type PublicSchema struct{…}` A schema used in schema validation - `CreatedAt Time` - `Kind PublicSchemaKind` The kind of the schema - `const PublicSchemaKindOpenAPIV3 PublicSchemaKind = "openapi_v3"` - `Name string` A human-readable name for the schema - `SchemaID string` A unique identifier of this schema - `Source string` The raw schema, e.g., the OpenAPI schema, either as JSON or YAML - `ValidationEnabled bool` An indicator if this schema is enabled ### Example ```go package main import ( "context" "fmt" "github.com/cloudflare/cloudflare-go" "github.com/cloudflare/cloudflare-go/option" "github.com/cloudflare/cloudflare-go/schema_validation" ) func main() { client := cloudflare.NewClient( option.WithAPIToken("Sn3lZJTBX6kkg7OdcBUAxOO963GEIyGQqnFTOFYY"), ) publicSchema, err := client.SchemaValidation.Schemas.Edit( context.TODO(), "f174e90a-fafe-4643-bbbc-4a0ed4fc8415", schema_validation.SchemaEditParams{ ZoneID: cloudflare.F("023e105f4ecef8ad9ca31a8372d0c353"), }, ) if err != nil { panic(err.Error()) } fmt.Printf("%+v\n", publicSchema.SchemaID) } ``` #### Response ```json { "errors": [ { "code": 1000, "message": "message", "documentation_url": "documentation_url", "source": { "pointer": "pointer" } } ], "messages": [ { "code": 1000, "message": "message", "documentation_url": "documentation_url", "source": { "pointer": "pointer" } } ], "result": { "created_at": "2014-01-01T05:20:00.12345Z", "kind": "openapi_v3", "name": "petstore schema", "schema_id": "f174e90a-fafe-4643-bbbc-4a0ed4fc8415", "source": "", "validation_enabled": true }, "success": true } ``` ## Delete a schema `client.SchemaValidation.Schemas.Delete(ctx, schemaID, body) (*SchemaDeleteResponse, error)` **delete** `/zones/{zone_id}/schema_validation/schemas/{schema_id}` Permanently removes an uploaded OpenAPI schema from API Shield. Operations using this schema will lose their validation rules. ### Parameters - `schemaID string` UUID. - `body SchemaDeleteParams` - `ZoneID param.Field[string]` Identifier. ### Returns - `type SchemaDeleteResponse struct{…}` - `ID string` The ID of the schema that was just deleted ### Example ```go package main import ( "context" "fmt" "github.com/cloudflare/cloudflare-go" "github.com/cloudflare/cloudflare-go/option" "github.com/cloudflare/cloudflare-go/schema_validation" ) func main() { client := cloudflare.NewClient( option.WithAPIToken("Sn3lZJTBX6kkg7OdcBUAxOO963GEIyGQqnFTOFYY"), ) schema, err := client.SchemaValidation.Schemas.Delete( context.TODO(), "f174e90a-fafe-4643-bbbc-4a0ed4fc8415", schema_validation.SchemaDeleteParams{ ZoneID: cloudflare.F("023e105f4ecef8ad9ca31a8372d0c353"), }, ) if err != nil { panic(err.Error()) } fmt.Printf("%+v\n", schema.ID) } ``` #### Response ```json { "errors": [ { "code": 1000, "message": "message", "documentation_url": "documentation_url", "source": { "pointer": "pointer" } } ], "messages": [ { "code": 1000, "message": "message", "documentation_url": "documentation_url", "source": { "pointer": "pointer" } } ], "result": { "id": "182bd5e5-6e1a-4fe4-a799-aa6d9a6ab26e" }, "success": true } ``` ## Domain Types ### Public Schema - `type PublicSchema struct{…}` A schema used in schema validation - `CreatedAt Time` - `Kind PublicSchemaKind` The kind of the schema - `const PublicSchemaKindOpenAPIV3 PublicSchemaKind = "openapi_v3"` - `Name string` A human-readable name for the schema - `SchemaID string` A unique identifier of this schema - `Source string` The raw schema, e.g., the OpenAPI schema, either as JSON or YAML - `ValidationEnabled bool` An indicator if this schema is enabled